import java.net.*;
import java.io.*;
import java.util.*;

import java.awt.*;
import java.awt.geom.*;

public class UDPWinShareSend implements Runnable {
    public static final int maxPixels = UDPWinShareRecv.maxPixels;
    public static final int maxlen = UDPWinShareRecv.maxlen;
    UDPClient cli;
    ToyGraphics tg;
    int interval = 3; // seconds
    
    public UDPWinShareSend(UDPClient cli, ToyGraphics tg) {
	this.cli = cli;
	this.tg = tg;
    }
    public void run() {
	byte[] buf = new byte[maxlen];
	try {
	    for (;;) {
		for (int y=0; y<tg.height; y++) {
		    for (int x=0; x <tg.width; x+=maxPixels) {
			int len=maxPixels;
			if (x+len > tg.width) len = tg.width - x;
			int[] pixels = new int[len];
			synchronized (tg.g2d) {
			    for (int i=0; i<len; i++) {
				pixels[i] = tg.image.getRGB(x+i,y);
			    }
			}
			setBuf(buf,x,y,pixels);
			cli.send(buf);
		    }
		    Thread.sleep(10);
		}
		Thread.sleep(interval * 1000);
	    }
	} catch (IOException e) {
	    System.err.println("io exception");
	} catch (InterruptedException e) { // for Thread.sleep
	    System.err.println("interrupted exception");
	}
	System.out.println("stop");
	cli.close();
    }
    void setBuf(byte[] buf,int x,int y,int[] pixels) {
	buf[0] = (byte) ((x >>> 24) & 0xff);
	buf[1] = (byte) ((x >>> 16) & 0xff);
	buf[2] = (byte) ((x >>> 8) & 0xff);
	buf[3] = (byte) (x & 0xff);
	buf[4] = (byte) ((y >>> 24) & 0xff);
	buf[5] = (byte) ((y >>> 16) & 0xff);
	buf[6] = (byte) ((y >>> 8) & 0xff);
	buf[7] = (byte) (y & 0xff);
	for (int i=0; i<pixels.length; i++) {
	    buf[8 + 3*i] = (byte) ((pixels[i] >> 16) & 0xff); // Red
	    buf[8 + 3*i + 1] = (byte) ((pixels[i] >> 8) & 0xff); // Green
	    buf[8 + 3*i + 2] = (byte) (pixels[i] & 0xff); //Blue
	}

    }
}
